BeamAndGo.Member.Web/Pages/AddressManagement.cshtml.cs
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member.Web.Filters;
using BeamAndGo.Member.Web.Models.FormData;
using BeamAndGo.Member.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Web.Pages
{
    [LoginRequired]
    public class AddressManagementModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<AddressManagementModel> _logger;
        private readonly IMemberService _memberService;
        private readonly IMemberAddressService _memberAddressService;


        public bool KYCEnabled { get; set; }
        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public IAsyncEnumerable<MemberAddress> MemberAddresses { get; set; }
        public Member Member { get; set; }
        public string MemberCountryCode { get; set; }


        [BindProperty]
        public AddressFormData AddressFormData { get; set; }
        [BindProperty]
        public string MemberAddressSid { get; set; }
        
        
        public AddressManagementModel(ILogger<AddressManagementModel> logger,
                                      IMemberAddressService memberAddressService,
                                      IMemberService memberService,  
                                      IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _memberService = memberService;
            _memberAddressService = memberAddressService;
            _applicationOptions = applicationOptions.Value;
        }

        public async Task<IActionResult> OnGetAsync()
        {
            try
            {
                KYCEnabled = _applicationOptions.KYCEnabled;
                Member = await _memberService.GetBySid(HttpContext.Session.GetString(SessionKey.MemberSid));
                MemberCountryCode = Member?.CountryCode;

                MemberAddresses = _memberAddressService.ListByMemberSid(Member.Sid);
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostResendAddressAsync()
        {
            try
            {
                //Temporary not in use
                await _memberAddressService.Verify(MemberAddressSid, string.Empty);

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully resend a verification to your email");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to resend address {@MemberAddressSid}", MemberAddressSid);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return RedirectToPage("./Index");
        }

        public async Task<IActionResult> OnPostMakePrimaryAddressAsync(string addressSid)
        {
            try
            {
                await _memberAddressService.SetDefault(addressSid);
                return new OkObjectResult("Successfully updated your primary address");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to make primary {@addressSid}", addressSid);
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }

        public async Task<IActionResult> OnPostRemoveAddressAsync()
        {
            try
            {
                await _memberAddressService.Delete(MemberAddressSid);
                return new OkObjectResult("Successfully removed your address");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to remove address {@MemberAddressSid}", MemberAddressSid);
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }

        public async Task<IActionResult> OnPostAddAddressAsync()
        {
            try
            {
                if (ModelState.IsValid)
                {
                    var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                    await _memberAddressService.Create(
                        sid,
                        AddressFormData.Name,
                        AddressFormData.Street,
                        AddressFormData.PostalCode,
                        AddressFormData.Country
                    );
                    return new OkObjectResult("Successfully added your address");
                }
                else
                {
                    return BadRequest("Please enter a valid address");
                }
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to add address");
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }
    }
}

BeamAndGo.Member.Web/Pages/CreateNewRelationship.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member.Web.Filters;
using BeamAndGo.Member.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Web.Pages
{
    [LoginRequired]
    public class CreateNewRelationshipModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<CreateNewRelationshipModel> _logger;
        private readonly IMemberService _memberService;
        private readonly IMemberRelationshipService _memberRelationshipService;
        private readonly IMemberRelationshipTypeService _memberRelationshipTypeService;


        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public IEnumerable<MemberRelationshipType> RelationshipTypes { get; private set; }
        public string MaxBirthdate { get; set; }
        public string MinBirthdate { get; set; }
        public string MemberCountryCode { get; set; }
        public string StaticAssetsUrl { get; set; }


        [BindProperty]
        public CreateMemberRelationshipData FormData { get; set; }

        [BindProperty]
        public string RelationshipBirthdate { get; set; }
        [BindProperty]
        public string RelationshipType { get; set; }


        public CreateNewRelationshipModel(ILogger<CreateNewRelationshipModel> logger, 
                                          IMemberRelationshipService memberRelationshipService, 
                                          IMemberRelationshipTypeService memberRelationshipTypeService,
                                          IMemberService memberService,
                                          IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _memberRelationshipService = memberRelationshipService;
            _memberRelationshipTypeService = memberRelationshipTypeService;
            _memberService = memberService;
            _applicationOptions = applicationOptions.Value;
            FormData = new CreateMemberRelationshipData();
        }

        public async Task<IActionResult> OnGetAsync()
        {
            var sid = HttpContext.Session.GetString(SessionKey.MemberSid);

            try
            {
                MinBirthdate = DateTime.Now.AddYears(-100).ToString("yyyy-MM-dd");
                MaxBirthdate = DateTime.Now.AddYears(-1).ToString("yyyy-MM-dd");
                StaticAssetsUrl = _applicationOptions.StaticAssetsUrl;

                RelationshipTypes = await _memberRelationshipTypeService.ListAllActiveSortedByName();

                var member = await _memberService.GetBySid(sid);
                MemberCountryCode = member?.CountryCode;
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostCreateAsync()
        {
            if (ModelState.IsValid)
            {
                try
                {
                    FormData.MemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                    var birthDate = Convert.ToDateTime(RelationshipBirthdate);
                    if (birthDate.Year > 1)
                    {
                        FormData.BirthDay = birthDate.Day;
                        FormData.BirthMonth = birthDate.Month;
                        FormData.BirthYear = birthDate.Year;
                    }

                    if (RelationshipType != null)
                    {
                        FormData.RelationshipTypeId = Convert.ToInt32(RelationshipType.Split("|")[0]);
                    }

                    var relationship = await _memberRelationshipService.Create(FormData);

                    return new OkObjectResult("Successfully added new relationship");
                }
                catch (ArgumentException ex)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
                }
                catch (Exception ex)
                {
                    if (ex is InvalidOperationException)
                    {
                        _logger.LogInformation(ex, ex.Message);
                        return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                    }
                    else
                    {
                        _logger.LogError(ex, ex.Message);
                        return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                    }                
                }
            }
            else
            {
                var message = string.Join("\n", ModelState.Values
                                    .SelectMany(v => v.Errors)
                                    .Select(e => e.ErrorMessage));

                return BadRequest(message);
            }
        }
    }
}

BeamAndGo.Member.Web/Pages/Message.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace BeamAndGo.Member.Web.Pages
{
    public class MessageModel : PageModel
    {
        public string Message { get; set; }

        public IActionResult OnGet([FromQuery(Name = "msg")] string msg = "msg")
        {
            Message = msg;
            return Page();
        }
    }
}

BeamAndGo.Member.Web/Pages/Preference.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member.Web.Filters;
using BeamAndGo.Member.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace BeamAndGo.Member.Web.Pages
{
    [LoginRequired]
    public class PreferenceModel : PageModel
    {
        private readonly ILogger<PreferenceModel> _logger;
        private readonly IMemberPreferenceService _memberPreferenceService;
        private readonly IMemberPreferenceTypeService _memberPreferenceTypeService;


        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public IAsyncEnumerable<MemberPreference> MemberPreferences { get; set; }


        [BindProperty]
        public string CurrentSelectedValue { get; set; }
        [BindProperty]
        public string SelectedPreferenceTypeId { get; set; }


        public PreferenceModel(ILogger<PreferenceModel> logger,
                                            IMemberPreferenceService memberPreferenceService,
                                            IMemberPreferenceTypeService memberPreferenceTypeService)
        {
            _logger = logger;
            _memberPreferenceService = memberPreferenceService;
            _memberPreferenceTypeService = memberPreferenceTypeService;
        }
        public IActionResult OnGet()
        {
            var sid = HttpContext.Session.GetString(SessionKey.MemberSid);

            try
            {
                MemberPreferences = _memberPreferenceService.ListWithDefaultByMemberSid(sid);
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostUpdatePreferenceAsync()
        {
            var sid = HttpContext.Session.GetString(SessionKey.MemberSid);

            try
            {
                if (CurrentSelectedValue.ToLower() == "true")
                {
                    await _memberPreferenceService.CreateOrUpdate(sid, Convert.ToInt32(SelectedPreferenceTypeId), "true");
                }
                else
                {
                    await _memberPreferenceService.CreateOrUpdate(sid, Convert.ToInt32(SelectedPreferenceTypeId), "false");
                }

                return new OkObjectResult("Successfully updated Preference");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, $"Failed to update Communication Preference");
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }
    }
}

BeamAndGo.Member.Web/Pages/AddressManagement.cshtml
@page
@model BeamAndGo.Member.Web.Pages.AddressManagementModel
@{
    ViewData["Title"] = "Address Management";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";

}

<style>
    .country-select {
        width: 100% !important;
    }
</style>

<div class="@(!Model.IsXHR ? "uk-container" : "")">
    <div class="uk-margin-small">
        <h3>Address Management</h3>
        <div class="uk-margin">
            @await foreach (var address in Model.MemberAddresses)
            {
                <div class="uk-margin-small @(address.IsDefault ? "uk-text-bold" : "")">
                    <div class="uk-card uk-card-default uk-card-small uk-card-body uk-width-1-1">
                        <div uk-grid>
                            <div class=" uk-width-expand@s">
                                <p class="uk-form-label uk-margin-remove">@address.Name</p>
                                <p class="uk-form-label uk-margin-remove">@address.Street</p>
                                <p class="uk-form-label uk-margin-remove">@address.CountryCode @address.PostalCode</p>
                            </div>
                            <div class="uk-width-auto@s uk-margin-remove">
                                <p class="uk-margin-remove uk-text-left@s uk-text-right@m">
                                    @if (address.IsDefault)
                                    {
                                        <span class="uk-badge uk-label uk-label-success">Primary</span>
                                    }
                                    @if (Model.KYCEnabled)
                                    {
                                        @if (address.IsVerified)
                                        {
                                            <span class="uk-badge uk-label uk-label-success">Verified</span>
                                        }
                                        else
                                        {
                                            <span class="uk-badge uk-label uk-label-warning">Unverified</span>
                                        }
                                    }
                                </p>
                            </div>
                        </div>
                        <div class="uk-margin-medium-top uk-align-right uk-flex-inline">

                            @if (!address.IsDefault)
                            {
                                @if (!address.IsVerified)
                                {
                                    <form asp-page-handler="MakePrimaryAddress"
                                          method="post"
                                          asp-antiforgery="true"
                                          asp-route-addressSid="@address.Sid"
                                          data-ajax="true"
                                          data-ajax-method="post"
                                          data-ajax-success="makePrimaryAddressSuccess"
                                          data-ajax-failure="makePrimaryAddressFailed">
                                        <button class="member-address-make-primary uk-button uk-button-small uk-text-nowrap"
                                                style="padding:5px 10px;"
                                                type="submit"
                                                memberAddressSid="@address.Sid">
                                            <i class="fas fa-star uk-margin-small-right"></i>Make Primary
                                        </button>
                                    </form>
                                }

                                <div class="uk-margin-small-left">
                                    <button class="member-address-remove uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            uk-toggle="target: #modal-address-remove"
                                            memberAddressSid="@address.Sid"
                                            memberAddress="@address.Name <br /> @address.Street <br /> @address.CountryCode @address.PostalCode <br />">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            }
        </div>
        <div class="uk-align-right">
            <a class="uk-button uk-button-primary" uk-toggle="target: #modal-address-add">Add New Address</a>
        </div>
    </div>
</div>
<!-- This is the modal for ResendAddress -->
<div id="modal-address-resend-verification" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p>A verification email has been sent to your e-mail address. Please follow the instructions in your email to verify your e-mail address</p>
        <form class="uk-margin" method="post" asp-page-handler="ResendAddress" asp-antiforgery="true">
            <input asp-for="@Model.MemberAddressSid" class="member-address-resend-verification-input" type="hidden">
            <button class="uk-button uk-button-primary" type="submit">Ok</button>
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for RemoveAddress -->
<div id="modal-address-remove" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p class="uk-margin-remove"> Are you sure you want to remove this Address? </p>
        <p class="uk-margin-remove modal-address"></p>
        <form class="uk-margin" method="post" asp-page-handler="RemoveAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="removeAddressSuccess" data-ajax-failure="removeAddressFailed">
            <input asp-for="@Model.MemberAddressSid" class="member-address-remove-input" type="hidden">
            <button class="uk-button uk-button-primary" type="submit">Yes</button>
            @if (Model.IsXHR)
            {
                <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>No</a>
            }
            else
            {
                <button class="uk-button uk-button-default uk-modal-close" type="button">No</button>
            }
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for AddAddress -->
<div id="modal-address-add" uk-modal>
    <div class="uk-modal-dialog uk-modal-body">
        <h2 class="uk-modal-title">Add address</h2>
        <form class="uk-margin" method="post" asp-page-handler="AddAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="addAddressSuccess" data-ajax-failure="addAddressFailed">
            <div class="uk-margin-small">
                <div>
                    <label asp-for="AddressFormData.Name" class="uk-form-label"></label>
                    <input asp-for="AddressFormData.Name" class="uk-input" type="text" maxlength="128" required>
                    <span asp-validation-for="AddressFormData.Name" class="uk-text-danger uk-text-small"></span>
                </div>
                <div>
                    <label asp-for="AddressFormData.Street" class="uk-form-label"></label>
                    <textarea asp-for="AddressFormData.Street" class="uk-textarea" rows="3" type="text" maxlength="128"></textarea>
                    <span asp-validation-for="AddressFormData.Street" class="uk-text-danger uk-text-small"></span>
                </div>
                <div class=" uk-grid-small" uk-grid>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.PostalCode" class="uk-form-label"></label>
                        <input asp-for="AddressFormData.PostalCode" class="uk-input" type="text" placeholder="" maxlength="128" required>
                        <span asp-validation-for="AddressFormData.PostalCode" class="uk-text-danger uk-text-small"></span>
                    </div>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.Country" class="uk-form-label"></label>
                        <input id="address-country-code" class="uk-input" type="text" readonly="readonly">
                        <input type="hidden" id="new-address-country-code" asp-for="AddressFormData.Country">
                        <span asp-validation-for="AddressFormData.Country" class="uk-text-danger uk-text-small"></span>
                    </div>
                </div>
            </div>
            <p class="uk-text-right">
                <button class="uk-button uk-button-primary" type="submit">Add Address</button>
                @if (Model.IsXHR)
                {
                    <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>Cancel</a>
                }
                else
                {
                    <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                }
            </p>
        </form>
    </div>
</div>
<!-- End of modal -->
<script>
    //Country
    $(document).ready(function () {
        selectedAddressCountry();
    });

     $("#address-country-code").countrySelect({
        defaultCountry: '@Model.MemberCountryCode.ToLower()',
        preferredCountries: ["au", "ca", "hk", "jp", "my", "ph", "qa", "sa", "sg", "tw", "ae", "us", "gb"],
    });

    function selectedAddressCountry() {
        var country_code = $("#address-country-code").countrySelect("getSelectedCountryData");
        $("#new-address-country-code").val(country_code.iso2.toUpperCase());
    }

    $("#address-country-code").change(function () {
        selectedAddressCountry();
    });


    //
    $('.member-address-resend-verification').click(function () {
        $('.member-address-resend-verification-input').val($(this).attr('memberAddressSid'));
    });
    $('.member-address-remove').click(function () {
        $('.member-address-remove-input').val($(this).attr('memberAddressSid'));
        $('.modal-address').html($(this).attr('memberAddress'));
    });


    // Add Address
    addAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    addAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Remove Address
    removeAddressSuccess = (xhr) => {
        $("#modal-address-remove").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    removeAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Make Primary Address
    makePrimaryAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    makePrimaryAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };
</script>

BeamAndGo.Member.Web/Pages/Message.cshtml
@page
@model BeamAndGo.Member.Web.Pages.MessageModel
@{
    ViewData["Title"] = "Message";
}
<div class="uk-container">
    <div class="uk-flex">
        <div class="uk-margin-auto uk-margin-medium-top uk-text-center">
            <h3 class="text-nowrap">@Model.Message</h3>

            <div class="uk-margin-small"><a class="uk-button uk-button-primary" asp-page="./Index">My Profile</a></div>

        </div>
    </div>
</div>